Index: engine/jitc_pinvoke.c
===================================================================
RCS file: /sources/dotgnu-pnet/./pnet/engine/jitc_pinvoke.c,v
retrieving revision 1.3
diff -c -r1.3 jitc_pinvoke.c
*** engine/jitc_pinvoke.c	28 Jul 2006 17:41:54 -0000	1.3
--- engine/jitc_pinvoke.c	16 Sep 2006 13:26:34 -0000
***************
*** 1825,1867 ****
      }
      else if(ILType_IsValueType(type))
      {	
! 	    if(addressKind==MARSHAL_FIRST_LEVEL_VALUE) return (ILJitValue)MarshalDelegateStruct(function, jit_insn_address_of(function, in), type, 0, 0, MARSHAL_FIRST_LEVEL_VALUE, thread);
! 	    retValue = (ILJitValue)MarshalDelegateStruct(function, in, type, outAddressValue, offset, MARSHAL_ITEM_OF_STRUCTURE, thread);
  	    jit_insn_store_relative(function, outAddressValue, offset, retValue);
  	    return retValue;
      }
      else if(ILTypeIsStringClass(type))
      {
! 	    args[0] = jit_value_create_nint_constant(function, _IL_JIT_TYPE_VPTR, (jit_nint)thread);
  	    if(addressKind==MARSHAL_FIRST_LEVEL_VALUE) args[1] = in;
  	    else args[1] = jit_insn_load_relative(function, in, offset, _IL_JIT_TYPE_VPTR);
  	    switch(marshalType)
  	    {
  			case IL_META_MARSHAL_ANSI_STRING:
  			{
! 				    jit_insn_store(function, temp, jit_insn_call_native(function,
! 						    "ILStringCreate",
! 						    ILStringCreate,
! 						    _ILJitSignature_ILStringCreate,
! 						    args, 2, JIT_CALL_NOTHROW));
  			}
  			break;
  			case IL_META_MARSHAL_UTF8_STRING:
  			{
! 				    jit_insn_store(function, temp, jit_insn_call_native(function,
! 						    "ILStringCreateUTF8",
! 						    ILStringCreateUTF8,
! 						    _ILJitSignature_ILStringCreateUTF8,
! 						    args, 2, JIT_CALL_NOTHROW));
  			}
  			break;
  			case IL_META_MARSHAL_UTF16_STRING:
  			{
! 				    jit_insn_store(function, temp, jit_insn_call_native(function,
! 						    "ILStringWCreate",
! 						    ILStringWCreate,
! 						    _ILJitSignature_ILStringWCreate,
! 						    args, 2, JIT_CALL_NOTHROW));
  			}
  			break;
  	    }
--- 2338,2392 ----
      }
      else if(ILType_IsValueType(type))
      {	
! 	    if(addressKind==MARSHAL_FIRST_LEVEL_VALUE) return (ILJitValue)MarshalDelegateStruct(function, jit_insn_address_of(function, in), type, marshalType, 0, 0, MARSHAL_FIRST_LEVEL_VALUE);
! 	    retValue = (ILJitValue)MarshalDelegateStruct(function, in, type, marshalType, outAddressValue, offset, MARSHAL_ITEM_OF_STRUCTURE);
  	    jit_insn_store_relative(function, outAddressValue, offset, retValue);
  	    return retValue;
      }
      else if(ILTypeIsStringClass(type))
      {
! 	    args[0] = _ILJitFunctionGetThread(function);
  	    if(addressKind==MARSHAL_FIRST_LEVEL_VALUE) args[1] = in;
  	    else args[1] = jit_insn_load_relative(function, in, offset, _IL_JIT_TYPE_VPTR);
+ 	    char *customName;
+ 	    int customNameLen;
+ 	    char *customCookie;
+ 	    int customCookieLen;
+ 	    ILMethod *method = (ILMethod *)jit_function_get_meta(function, IL_JIT_META_METHOD);
+ 	    marshalType = ILPInvokeGetMarshalType
+ 				(0, method, 0, &customName, &customNameLen, &customCookie, &customCookieLen, type);
  	    switch(marshalType)
  	    {
  			case IL_META_MARSHAL_ANSI_STRING:
  			{
! 				temp = jit_insn_call_native(function,
! 							    "ILStringCreate",
! 							    ILStringCreate,
! 							    _ILJitSignature_ILStringCreate,
! 							    args, 2, JIT_CALL_NOTHROW);
  			}
  			break;
  			case IL_META_MARSHAL_UTF8_STRING:
  			{
! 				temp = jit_insn_call_native(function,
! 							    "ILStringCreateUTF8",
! 							    ILStringCreateUTF8,
! 							    _ILJitSignature_ILStringCreateUTF8,
! 							    args, 2, JIT_CALL_NOTHROW);
  			}
  			break;
  			case IL_META_MARSHAL_UTF16_STRING:
  			{
! 				temp = jit_insn_call_native(function,
! 							    "ILStringWCreate",
! 							    ILStringWCreate,
! 							    _ILJitSignature_ILStringWCreate,
! 							    args, 2, JIT_CALL_NOTHROW);
! 			}
! 			break;
! 			default:
! 			{
! 				temp = args[1];
  			}
  			break;
  	    }
***************
*** 1877,1891 ****
  	    jit_insn_store_relative(function, outAddressValue, offset, temp);
  	    return temp;
      }
!     else if(ILType_IsClass(type))
!     {
! 	    if(addressKind==MARSHAL_FIRST_LEVEL_VALUE) return in;
! 	    temp = jit_insn_load_relative(function, in, offset, _IL_JIT_TYPE_VPTR);
! 	    jit_insn_store_relative(function, outAddressValue, offset, temp);
! 	    retValue = temp;
! 	    return retValue;
!     }
!     else if(type !=0 && ILType_IsComplex(type))
      {
  	    switch(ILType_Kind(type))
  	    {
--- 2402,2408 ----
  	    jit_insn_store_relative(function, outAddressValue, offset, temp);
  	    return temp;
      }
!     else if(type!=0 && ILType_IsComplex(type))
      {
  	    switch(ILType_Kind(type))
  	    {
***************
*** 1895,1901 ****
  			    temp = jit_insn_load_relative(function, in, offset, _IL_JIT_TYPE_VPTR);
  			    jit_insn_store_relative(function, outAddressValue, offset, temp);
  			    return temp;
! 		    };
  		    break;
  		    case IL_TYPE_COMPLEX_BYREF:
  		    {
--- 2412,2418 ----
  			    temp = jit_insn_load_relative(function, in, offset, _IL_JIT_TYPE_VPTR);
  			    jit_insn_store_relative(function, outAddressValue, offset, temp);
  			    return temp;
! 		    }
  		    break;
  		    case IL_TYPE_COMPLEX_BYREF:
  		    {
***************
*** 1903,1916 ****
  				    jit_insn_store(function, srcArray, jit_insn_load_relative(function, in, offset, _IL_JIT_TYPE_VPTR));
  			    else jit_insn_store(function, srcArray, in);
  			    ILType *elemType = ILType_Ref(type);
  			    if(NeedMarshalValue(elemType))
  			    {
  				    jit_insn_store(function, temp, MarshalDelegateStruct(function, jit_insn_dup(function, srcArray),
  									    elemType,
  									    0,
  									    0,
! 									    MARSHAL_FIRST_LEVEL_VALUE,
! 									    thread));
  			    }
  			    else jit_insn_store(function, temp, srcArray);
  			    if(addressKind==MARSHAL_ITEM_OF_STRUCTURE || addressKind==MARSHAL_ITEM_OF_ARRAY)
--- 2420,2434 ----
  				    jit_insn_store(function, srcArray, jit_insn_load_relative(function, in, offset, _IL_JIT_TYPE_VPTR));
  			    else jit_insn_store(function, srcArray, in);
  			    ILType *elemType = ILType_Ref(type);
+ 			    elemType = ILTypeGetEnumType(elemType);
  			    if(NeedMarshalValue(elemType))
  			    {
  				    jit_insn_store(function, temp, MarshalDelegateStruct(function, jit_insn_dup(function, srcArray),
  									    elemType,
+ 									    marshalType,
  									    0,
  									    0,
! 									    MARSHAL_FIRST_LEVEL_VALUE));
  			    }
  			    else jit_insn_store(function, temp, srcArray);
  			    if(addressKind==MARSHAL_ITEM_OF_STRUCTURE || addressKind==MARSHAL_ITEM_OF_ARRAY)
***************
*** 1918,1929 ****
  			    return srcArray;
  		    }
  		    break;
- 		    case IL_TYPE_COMPLEX_PINNED:
- 		    {
- 			    fprintf(stderr, "Marshaling in a delegate a COMPLEX_PINNED type is not yet supported\n");
- 			    return 0;
- 		    }
- 		    break;
  		    default: break;
  	    }
  
--- 2436,2441 ----
***************
*** 1933,1952 ****
  			    if(addressKind==MARSHAL_ITEM_OF_STRUCTURE || addressKind==MARSHAL_ITEM_OF_ARRAY)
  				    srcArray = jit_insn_load_relative(function, srcArray, offset, _IL_JIT_TYPE_VPTR);
  			    elemType = ILType_ElemType(type);
! 
! 			    // The size of a simple array can be known only on run-time.
  			    arraySize = jit_insn_load_relative(function, srcArray, 0, _IL_JIT_TYPE_UINT32);
  			    srcElemSize = jit_value_create_nint_constant(function,
  				    						_IL_JIT_TYPE_INT32,
! 										(jit_nint)(ILSizeOfType(thread, elemType)));
  			    newElemSize = jit_value_create_nint_constant(function,
  										_IL_JIT_TYPE_INT32,
! 									    	(jit_nint)(ILSizeOfType(thread, elemType)));
  			    newArraySize = jit_insn_mul(function, arraySize, newElemSize);
  			    newArraySize = jit_insn_add_relative(function, newArraySize, (jit_nint)(sizeof(ILUInt32)));
  			    args[0] = newArraySize;
! 			    newArray = jit_insn_call_native(function, "_ILMalloc",
! 			    		    				ILGCAlloc,
  			    		    				_ILJitSignature_malloc,
  									args, 1, 0);
  			    jit_insn_store_relative(function, newArray, 0, arraySize);
--- 2445,2467 ----
  			    if(addressKind==MARSHAL_ITEM_OF_STRUCTURE || addressKind==MARSHAL_ITEM_OF_ARRAY)
  				    srcArray = jit_insn_load_relative(function, srcArray, offset, _IL_JIT_TYPE_VPTR);
  			    elemType = ILType_ElemType(type);
! 			    elemType = ILTypeGetEnumType(elemType);
! 			    jit_insn_store(function, newArray, srcArray);
! 			    jit_insn_branch_if_not(function, jit_insn_to_bool(function, srcArray),
! 							    &endLoop);
!     			    // The size of a simple array can be known only on run-time.
  			    arraySize = jit_insn_load_relative(function, srcArray, 0, _IL_JIT_TYPE_UINT32);
  			    srcElemSize = jit_value_create_nint_constant(function,
  				    						_IL_JIT_TYPE_INT32,
! 										(jit_nint)(ILSizeOfType(ILExecThreadCurrent(), elemType)));
  			    newElemSize = jit_value_create_nint_constant(function,
  										_IL_JIT_TYPE_INT32,
! 									    	(jit_nint)(ILSizeOfType(ILExecThreadCurrent(), elemType)));
  			    newArraySize = jit_insn_mul(function, arraySize, newElemSize);
  			    newArraySize = jit_insn_add_relative(function, newArraySize, (jit_nint)(sizeof(ILUInt32)));
  			    args[0] = newArraySize;
! 			    newArray = jit_insn_call_native(function, "_ILGCAllocAtomic",
! 			    		    				ILGCAllocAtomic,
  			    		    				_ILJitSignature_malloc,
  									args, 1, 0);
  			    jit_insn_store_relative(function, newArray, 0, arraySize);
***************
*** 1962,1979 ****
  												_IL_JIT_TYPE_INT32,
  												(jit_nint)(sizeof(ILUInt32))));
  			    newElemAddress = jit_insn_dup(function, newArray);
! 			    counter = arraySize;
  			    jit_insn_label(function, &startLoop);
  			    jit_insn_store(function, counter, jit_insn_sub(function, counter,
  		    									jit_value_create_nint_constant(function,
  											_IL_JIT_TYPE_INT32,
  											1)));
  			    MarshalDelegateValue(function, srcElemAddress,
! 							elemType, current,
  							MARSHAL_ITEM_OF_ARRAY,
  							0,
! 							newElemAddress,
! 							thread);
  			    jit_insn_store(function, srcElemAddress,
  							    jit_insn_add(function,
  							    srcElemAddress, srcElemSize));
--- 2477,2493 ----
  												_IL_JIT_TYPE_INT32,
  												(jit_nint)(sizeof(ILUInt32))));
  			    newElemAddress = jit_insn_dup(function, newArray);
! 			    counter = jit_insn_dup(function, arraySize);
  			    jit_insn_label(function, &startLoop);
  			    jit_insn_store(function, counter, jit_insn_sub(function, counter,
  		    									jit_value_create_nint_constant(function,
  											_IL_JIT_TYPE_INT32,
  											1)));
  			    MarshalDelegateValue(function, srcElemAddress,
! 							elemType, marshalType,
  							MARSHAL_ITEM_OF_ARRAY,
  							0,
! 							newElemAddress);
  			    jit_insn_store(function, srcElemAddress,
  							    jit_insn_add(function,
  							    srcElemAddress, srcElemSize));
***************
*** 1996,2039 ****
  
      }
  
!     // Should not reach here if all every case is above, however do something smart.
      if(addressKind==MARSHAL_FIRST_LEVEL_VALUE) return in;
      temp = jit_insn_load_relative(function, in, offset, _IL_JIT_TYPE_VPTR);
      jit_insn_store_relative(function, outAddressValue, offset, temp);
      return temp;
  }
  
! ILJitValue MarshalDelegateStruct(jit_function_t function, ILJitValue inAddress, ILType *structureILType, ILJitValue outAddress, jit_nint offset, unsigned int addressKind, ILExecThread *thread)
  {
      ILClass *classInfo = ILClassResolve(ILType_ToValueType(structureILType));
!     unsigned int structSize = ILSizeOfType(thread, structureILType);
      ILField *field = 0;
-     ILJitValue newStruct = 0;
      ILType *type;
!     ILJitType structType;	
! 
      if(addressKind==MARSHAL_FIRST_LEVEL_VALUE)
      {
  	    structType = jit_type_create_struct(0, 0, 0);
  	    jit_type_set_size_and_alignment(structType, structSize, 0);
  	    newStruct = jit_value_create(function, structType);
  	    outAddress = jit_insn_address_of(function, newStruct);
      }
- 
      while((field = (ILField *)ILClassNextMemberByKind
      		(classInfo, (ILMember *)field, IL_META_MEMBERKIND_FIELD)) != 0)
      {
  	    if(!ILField_IsStatic(field))
  	    {
  		    type = ILTypeGetEnumType(ILField_Type(field));
! 		    MarshalDelegateValue(function, inAddress, type, 1, MARSHAL_ITEM_OF_STRUCTURE, field->offset, outAddress, thread);
  	    }
      }
!     return jit_insn_dup(function, newStruct);
  }
- 	
  
! static ILJitValue MarshalDelegateReturnValue(jit_function_t function, ILJitValue in, ILType *type, unsigned int addressKind, jit_nint offset, ILJitValue outAddress, ILExecThread *thread)
  {
      ILJitValue outAddressValue = outAddress;
      ILJitValue temp = jit_value_create(function, _IL_JIT_TYPE_VPTR);
--- 2510,2553 ----
  
      }
  
!     // Should not reach here if every case is handled above,
!     // however we make the compiler happy.
      if(addressKind==MARSHAL_FIRST_LEVEL_VALUE) return in;
      temp = jit_insn_load_relative(function, in, offset, _IL_JIT_TYPE_VPTR);
      jit_insn_store_relative(function, outAddressValue, offset, temp);
      return temp;
  }
  
! ILJitValue MarshalDelegateStruct(jit_function_t function, ILJitValue inAddress, ILType *structureILType, ILUInt32 marshalType, ILJitValue outAddress, jit_nint offset, unsigned int addressKind)
  {
      ILClass *classInfo = ILClassResolve(ILType_ToValueType(structureILType));
!     unsigned int structSize = ILSizeOfType(ILExecThreadCurrent(), structureILType);
      ILField *field = 0;
      ILType *type;
!     ILJitType structType;
!     ILJitValue newStruct = 0;
      if(addressKind==MARSHAL_FIRST_LEVEL_VALUE)
      {
+ 	    // A structure passed to the delegate need to be a libjit value,
+ 	    // although we could use ILGCAllocAtomic with the structSize.
  	    structType = jit_type_create_struct(0, 0, 0);
  	    jit_type_set_size_and_alignment(structType, structSize, 0);
  	    newStruct = jit_value_create(function, structType);
  	    outAddress = jit_insn_address_of(function, newStruct);
      }
      while((field = (ILField *)ILClassNextMemberByKind
      		(classInfo, (ILMember *)field, IL_META_MEMBERKIND_FIELD)) != 0)
      {
  	    if(!ILField_IsStatic(field))
  	    {
  		    type = ILTypeGetEnumType(ILField_Type(field));
! 		    MarshalDelegateValue(function, inAddress, type, marshalType, MARSHAL_ITEM_OF_STRUCTURE, field->offset, outAddress);
  	    }
      }
!     return newStruct;
  }
  
! static ILJitValue MarshalDelegateReturnValue(jit_function_t function, ILJitValue in, ILType *type, ILUInt32 marshalType, unsigned int addressKind, jit_nint offset, ILJitValue outAddress)
  {
      ILJitValue outAddressValue = outAddress;
      ILJitValue temp = jit_value_create(function, _IL_JIT_TYPE_VPTR);
***************
*** 2042,2076 ****
      ILJitValue args[3];
      ILType *elemType;
      jit_label_t endLabel = jit_label_undefined;
!     ILJitValue srcArray = jit_value_create(function, _IL_JIT_TYPE_VPTR);    
!     ILUInt32 marshalType;
!     char *customName;
!     int customNameLen;
!     char *customCookie;
!     int customCookieLen;
!     ILMethod *method = (ILMethod *)jit_function_get_meta(function, IL_JIT_META_METHOD);
!     ILPInvoke *pinv = ILPInvokeFind(method);
!     marshalType = ILPInvokeGetMarshalType(pinv, method, 1, &customName, &customNameLen,
! 							&customCookie,	&customCookieLen, type);
! 
!     if(marshalType == IL_META_MARSHAL_DIRECT && addressKind==MARSHAL_FIRST_LEVEL_VALUE)
!     {
! 	    return in;
!     }    
!     else if(marshalType == IL_META_MARSHAL_CUSTOM)
      {
  	    fprintf(stderr, "Custom marshaling not supported in return value\n");
  	    return 0;
      }
-     type = ILTypeGetEnumType(type);
- 
-     if(addressKind==MARSHAL_FIRST_LEVEL_VALUE)
-     {
- 	    if(!NeedMarshalValue(type))return in;
-     }
  
!     if(addressKind==MARSHAL_ITEM_OF_ARRAY || addressKind == MARSHAL_ITEM_OF_STRUCTURE) outAddressValue = outAddress;
!     else if(addressKind!=MARSHAL_FIRST_LEVEL_VALUE && addressKind!=MARSHAL_ITEM_OF_STRUCTURE)
      {
  	    fprintf(stderr, "addressKind has an invalid value of %d\n", addressKind);
  	    return 0;
--- 2556,2570 ----
      ILJitValue args[3];
      ILType *elemType;
      jit_label_t endLabel = jit_label_undefined;
!     ILJitValue srcArray = jit_value_create(function, _IL_JIT_TYPE_VPTR);
!     type = ILTypeGetEnumType(type);    
!     if(marshalType == IL_META_MARSHAL_CUSTOM)
      {
  	    fprintf(stderr, "Custom marshaling not supported in return value\n");
  	    return 0;
      }
  
!     if(addressKind!=MARSHAL_FIRST_LEVEL_VALUE && addressKind!=MARSHAL_ITEM_OF_STRUCTURE && addressKind!=MARSHAL_ITEM_OF_ARRAY)
      {
  	    fprintf(stderr, "addressKind has an invalid value of %d\n", addressKind);
  	    return 0;
***************
*** 2214,2230 ****
  			{
  				case MARSHAL_ITEM_OF_ARRAY:
  				{
! 					return (ILJitValue)MarshalDelegateReturnStruct(function, valuePtr, refType, outAddressValue, offset, MARSHAL_ITEM_OF_ARRAY, thread);
  				}
  				break;
  				case MARSHAL_ITEM_OF_STRUCTURE:
  				{
! 					return (ILJitValue)MarshalDelegateReturnStruct(function, valuePtr, refType, outAddressValue, offset, MARSHAL_ITEM_OF_STRUCTURE, thread);
  				}
  				break;
  				default:
  				{
! 					return (ILJitValue)MarshalDelegateReturnStruct(function, valuePtr, refType, 0, 0, MARSHAL_FIRST_LEVEL_VALUE, thread);
  				}
  				break;
  			}
--- 2708,2724 ----
  			{
  				case MARSHAL_ITEM_OF_ARRAY:
  				{
! 					return (ILJitValue)MarshalDelegateReturnStruct(function, valuePtr, refType, marshalType, outAddressValue, offset, MARSHAL_ITEM_OF_ARRAY);
  				}
  				break;
  				case MARSHAL_ITEM_OF_STRUCTURE:
  				{
! 					return (ILJitValue)MarshalDelegateReturnStruct(function, valuePtr, refType, marshalType, outAddressValue, offset, MARSHAL_ITEM_OF_STRUCTURE);
  				}
  				break;
  				default:
  				{
! 					return (ILJitValue)MarshalDelegateReturnStruct(function, valuePtr, refType, marshalType, 0, 0, MARSHAL_FIRST_LEVEL_VALUE);
  				}
  				break;
  			}
***************
*** 2241,2295 ****
  		default:  break;
  	}			
      }
!     else if (ILType_IsValueType(type))
      {
  	    switch(addressKind)
  	    {
  		    case MARSHAL_ITEM_OF_STRUCTURE:
  		    case MARSHAL_ITEM_OF_ARRAY:
  		    {
! 			    return (ILJitValue)MarshalDelegateReturnStruct(function, in, type, outAddressValue, offset, MARSHAL_ITEM_OF_ARRAY, thread);
  		    }
  		    break;
  		    default:
  		    {
! 			    return (ILJitValue)MarshalDelegateReturnStruct(function, jit_insn_address_of(function, in), type, outAddressValue, 0, MARSHAL_FIRST_LEVEL_VALUE, thread);
  		    }
  		    break;
  	    }
      }
      else if(ILTypeIsStringClass(type))
      {
! 	    args[0] = jit_value_create_nint_constant(function, _IL_JIT_TYPE_VPTR, (jit_nint)thread);
  	    if(addressKind==MARSHAL_FIRST_LEVEL_VALUE) args[1] = in;
  	    else args[1] = jit_insn_load_relative(function, in, offset, _IL_JIT_TYPE_VPTR);
  	    switch(marshalType)
  	    {
  			case IL_META_MARSHAL_ANSI_STRING:
  			{
! 				    jit_insn_store(function, temp, jit_insn_call_native(function,
! 						    "ILStringToAnsi",
! 						    ILStringToAnsi,
! 						    _ILJitSignature_ILStringToAnsi,
! 						    args, 2, JIT_CALL_NOTHROW));
  			}
  			break;
  			case IL_META_MARSHAL_UTF8_STRING:
  			{
! 				    jit_insn_store(function, temp, jit_insn_call_native(function,
! 						    "ILStringToUTF8",
! 						    ILStringToUTF8,
! 						    _ILJitSignature_ILStringToUTF8,
! 						    args, 2, JIT_CALL_NOTHROW));
  			}
  			break;
  			case IL_META_MARSHAL_UTF16_STRING:
  			{
! 				    jit_insn_store(function, temp, jit_insn_call_native(function,
! 						    "ILStringToUTF16",
! 						    ILStringToUTF16,
! 						    _ILJitSignature_ILStringToUTF16,
! 						    args, 2, JIT_CALL_NOTHROW));
  			}
  			break;
  	    }
--- 2735,2801 ----
  		default:  break;
  	}			
      }
!     else if(ILType_IsValueType(type))
      {
  	    switch(addressKind)
  	    {
  		    case MARSHAL_ITEM_OF_STRUCTURE:
  		    case MARSHAL_ITEM_OF_ARRAY:
  		    {
! 			    return (ILJitValue)MarshalDelegateReturnStruct(function, in, type, marshalType, outAddressValue, offset, MARSHAL_ITEM_OF_ARRAY);
  		    }
  		    break;
  		    default:
  		    {
! 			    return (ILJitValue)MarshalDelegateReturnStruct(function, jit_insn_address_of(function, in), type, marshalType, outAddressValue, 0, MARSHAL_FIRST_LEVEL_VALUE);
  		    }
  		    break;
  	    }
      }
      else if(ILTypeIsStringClass(type))
      {
! 	    args[0] = _ILJitFunctionGetThread(function);
  	    if(addressKind==MARSHAL_FIRST_LEVEL_VALUE) args[1] = in;
  	    else args[1] = jit_insn_load_relative(function, in, offset, _IL_JIT_TYPE_VPTR);
+ 	    char *customName;
+ 	    int customNameLen;
+ 	    char *customCookie;
+ 	    int customCookieLen;
+ 	    ILMethod *method = (ILMethod *)jit_function_get_meta(function, IL_JIT_META_METHOD);
+ 	    marshalType = ILPInvokeGetMarshalType
+ 			    (0, method, 0, &customName, &customNameLen, &customCookie, &customCookieLen, type);
  	    switch(marshalType)
  	    {
  			case IL_META_MARSHAL_ANSI_STRING:
  			{
! 				temp = jit_insn_call_native(function,
! 							    "ILStringToAnsi",
! 							    ILStringToAnsi,
! 							    _ILJitSignature_ILStringToAnsi,
! 							    args, 2, JIT_CALL_NOTHROW);
  			}
  			break;
  			case IL_META_MARSHAL_UTF8_STRING:
  			{
! 				temp = jit_insn_call_native(function,
! 							    "ILStringToUTF8",
! 							    ILStringToUTF8,
! 							    _ILJitSignature_ILStringToUTF8,
! 							    args, 2, JIT_CALL_NOTHROW);
  			}
  			break;
  			case IL_META_MARSHAL_UTF16_STRING:
  			{
! 				temp = jit_insn_call_native(function,
! 							    "ILStringToUTF16",
! 							    ILStringToUTF16,
! 							    _ILJitSignature_ILStringToUTF16,
! 							    args, 2, JIT_CALL_NOTHROW);
! 			}
! 			break;
! 			default:
! 			{
! 				temp = args[1];
  			}
  			break;
  	    }
***************
*** 2303,2316 ****
  	    if(addressKind!=MARSHAL_FIRST_LEVEL_VALUE) temp = jit_insn_load_relative(function, in, offset, _IL_JIT_TYPE_VPTR);
  	    ILJitValue closure = jit_insn_load_relative(function, temp, offsetof(System_Delegate, closure), _IL_JIT_TYPE_VPTR);
  	    jit_insn_branch_if(function, jit_insn_to_bool(function, closure), &endLabel);
! 	    args[0] = jit_value_create_nint_constant(function, _IL_JIT_TYPE_VPTR, (jit_nint)thread);
! 	    args[1] = jit_insn_dup(function, temp);
! 	    args[2] = jit_value_create_nint_constant(function, _IL_JIT_TYPE_VPTR, (jit_nint)type);
  	    jit_insn_store(function, closure, jit_insn_call_native(function,
  					    "ILJitDelegateGetClosure",
  					    ILJitDelegateGetClosure,
  					    _ILJitSignature_ILJitDelegateGetClosure,
! 					    args, 3, JIT_CALL_NOTHROW));
  	    jit_insn_label(function, &endLabel);
  	    if(addressKind==MARSHAL_ITEM_OF_STRUCTURE || addressKind==MARSHAL_ITEM_OF_ARRAY)
  		    jit_insn_store_relative(function, outAddressValue, offset, closure);
--- 2809,2821 ----
  	    if(addressKind!=MARSHAL_FIRST_LEVEL_VALUE) temp = jit_insn_load_relative(function, in, offset, _IL_JIT_TYPE_VPTR);
  	    ILJitValue closure = jit_insn_load_relative(function, temp, offsetof(System_Delegate, closure), _IL_JIT_TYPE_VPTR);
  	    jit_insn_branch_if(function, jit_insn_to_bool(function, closure), &endLabel);
! 	    args[0] = jit_insn_dup(function, temp);
! 	    args[1] = jit_value_create_nint_constant(function, _IL_JIT_TYPE_VPTR, (jit_nint)type);
  	    jit_insn_store(function, closure, jit_insn_call_native(function,
  					    "ILJitDelegateGetClosure",
  					    ILJitDelegateGetClosure,
  					    _ILJitSignature_ILJitDelegateGetClosure,
! 					    args, 2, JIT_CALL_NOTHROW));
  	    jit_insn_label(function, &endLabel);
  	    if(addressKind==MARSHAL_ITEM_OF_STRUCTURE || addressKind==MARSHAL_ITEM_OF_ARRAY)
  		    jit_insn_store_relative(function, outAddressValue, offset, closure);
***************
*** 2335,2348 ****
  				    jit_insn_store(function, srcArray, jit_insn_load_relative(function, srcArray, offset, _IL_JIT_TYPE_VPTR));
  			    else jit_insn_store(function, srcArray, in);
  			    elemType = ILType_Ref(type);
  			    if(NeedMarshalValue(elemType))
  			    {
  				    MarshalDelegateReturnValue(function, jit_insn_dup(function, srcArray),
! 								elemType,
  								MARSHAL_ITEM_OF_ARRAY,
  								0,
! 								jit_insn_dup(function, srcArray),
! 								thread);
  			    }
  			    if(addressKind==MARSHAL_ITEM_OF_STRUCTURE || addressKind==MARSHAL_ITEM_OF_ARRAY)
  				    jit_insn_store_relative(function, outAddressValue, offset, srcArray);
--- 2840,2853 ----
  				    jit_insn_store(function, srcArray, jit_insn_load_relative(function, srcArray, offset, _IL_JIT_TYPE_VPTR));
  			    else jit_insn_store(function, srcArray, in);
  			    elemType = ILType_Ref(type);
+ 			    elemType = ILTypeGetEnumType(elemType);
  			    if(NeedMarshalValue(elemType))
  			    {
  				    MarshalDelegateReturnValue(function, jit_insn_dup(function, srcArray),
! 								elemType, marshalType,
  								MARSHAL_ITEM_OF_ARRAY,
  								0,
! 								jit_insn_dup(function, srcArray));
  			    }
  			    if(addressKind==MARSHAL_ITEM_OF_STRUCTURE || addressKind==MARSHAL_ITEM_OF_ARRAY)
  				    jit_insn_store_relative(function, outAddressValue, offset, srcArray);
***************
*** 2354,2361 ****
  
  		    if(ILType_IsSimpleArray(type))
  		    {
! 			    // The size of a simple array can be known only on run-time and we
! 			    // cannot use the same memory as it is used in the C code.
  			    fprintf(stderr, "Simple arrays are not supported for marshaling as a return value\n");
  			    return 0;
  		    }
--- 2859,2866 ----
  
  		    if(ILType_IsSimpleArray(type))
  		    {
! 			    // The size of a simple array can be known only on run-time but
! 			    // we should note that we cannot use the same memory as it is used in the C code.
  			    fprintf(stderr, "Simple arrays are not supported for marshaling as a return value\n");
  			    return 0;
  		    }
***************
*** 2372,2381 ****
      return temp;
  }
  
! static ILJitValue MarshalDelegateReturnStruct(jit_function_t function, ILJitValue inAddress, ILType *structureILType, ILJitValue outAddress, jit_nint offset, unsigned int addressKind, ILExecThread *thread)
  {
          ILClass *classInfo = ILClassResolve(ILType_ToValueType(structureILType));
!         unsigned int structSize = ILSizeOfType(thread, structureILType);
  	ILField *field = 0;
  	ILType *type;
  
--- 2877,2886 ----
      return temp;
  }
  
! static ILJitValue MarshalDelegateReturnStruct(jit_function_t function, ILJitValue inAddress, ILType *structureILType, ILUInt32 marshalType, ILJitValue outAddress, jit_nint offset, unsigned int addressKind)
  {
          ILClass *classInfo = ILClassResolve(ILType_ToValueType(structureILType));
!         unsigned int structSize = ILSizeOfType(ILExecThreadCurrent(), structureILType);
  	ILField *field = 0;
  	ILType *type;
  
***************
*** 2384,2390 ****
  		case MARSHAL_FIRST_LEVEL_VALUE:
  		{
  			ILJitValue sizeValue = jit_value_create_nint_constant(function, _IL_JIT_TYPE_UINT32, structSize);
! 			outAddress = jit_insn_call_native(function, "_ILMalloc",
  								    ILGCAlloc,
  								    _ILJitSignature_malloc,
  								    &sizeValue, 1, 0);
--- 2889,2895 ----
  		case MARSHAL_FIRST_LEVEL_VALUE:
  		{
  			ILJitValue sizeValue = jit_value_create_nint_constant(function, _IL_JIT_TYPE_UINT32, structSize);
! 			outAddress = jit_insn_call_native(function, "ILGCAlloc",
  								    ILGCAlloc,
  								    _ILJitSignature_malloc,
  								    &sizeValue, 1, 0);
***************
*** 2414,2440 ****
  			{
  				case MARSHAL_FIRST_LEVEL_VALUE:
  				{
! 					MarshalDelegateReturnValue(function, inAddress, type, MARSHAL_ITEM_OF_STRUCTURE, field->offset + offset, outAddress, thread);
  				}
  			        break;
  				case MARSHAL_ITEM_OF_STRUCTURE:
  				{
! 					MarshalDelegateReturnValue(function, inAddress, type, MARSHAL_ITEM_OF_STRUCTURE, field->offset + offset, outAddress, thread);
  				}
  				break;
  				default:
  				{
! 					MarshalDelegateReturnValue(function, inAddress, type, MARSHAL_ITEM_OF_ARRAY, field->offset + offset, outAddress, thread);
  				}
  				break;
  			}
  		}
  	}
- 	
  	return outAddress;
  }
  
! static void MarshalDelegateByRefValue(jit_function_t function, ILJitValue in, ILType *type, ILUInt32 current, unsigned int addressKind, jit_nint offset, ILJitValue outAddress, ILExecThread *thread)
  {
      ILJitValue outAddressValue;
      ILJitValue temp = jit_value_create(function, _IL_JIT_TYPE_VPTR);
--- 2919,2945 ----
  			{
  				case MARSHAL_FIRST_LEVEL_VALUE:
  				{
! 					MarshalDelegateReturnValue(function, inAddress, type, marshalType, MARSHAL_ITEM_OF_STRUCTURE, field->offset + offset, outAddress);
  				}
  			        break;
  				case MARSHAL_ITEM_OF_STRUCTURE:
  				{
! 					MarshalDelegateReturnValue(function, inAddress, type, marshalType, MARSHAL_ITEM_OF_STRUCTURE, field->offset + offset, outAddress);
  				}
  				break;
  				default:
  				{
! 					MarshalDelegateReturnValue(function, inAddress, type, marshalType, MARSHAL_ITEM_OF_ARRAY, field->offset + offset, outAddress);
  				}
  				break;
  			}
  		}
  	}
  	return outAddress;
  }
  
! #ifdef USE_BYREF_MARSHALING
! static void MarshalDelegateByRefValue(jit_function_t function, ILJitValue in, ILType *type, ILUInt32 marshalType, unsigned int addressKind, jit_nint offset, ILJitValue outAddress, ILExecThread *thread)
  {
      ILJitValue outAddressValue;
      ILJitValue temp = jit_value_create(function, _IL_JIT_TYPE_VPTR);
***************
*** 2448,2473 ****
      ILJitValue srcElemAddress;
      ILJitValue newElemAddress;
      ILJitValue counter;
!     ILJitValue arraySize;    
!     ILUInt32 marshalType;
!     char *customName;
!     int customNameLen;
!     char *customCookie;
!     int customCookieLen;
!     ILMethod *method = (ILMethod *)jit_function_get_meta(function, IL_JIT_META_METHOD);
!     ILPInvoke *pinv = ILPInvokeFind(method);
!     marshalType = ILPInvokeGetMarshalType(pinv, method, current, &customName, &customNameLen,
! 							&customCookie,	&customCookieLen, type);
!     if(marshalType == IL_META_MARSHAL_DIRECT && addressKind==MARSHAL_FIRST_LEVEL_VALUE)
!     {
! 	    return;
!     }
!     else if(marshalType == IL_META_MARSHAL_CUSTOM)
      {
  	    fprintf(stderr, "Custom marshaling not supported in delegate by ref value\n");
  	    return;
      }
-     type = ILTypeGetEnumType(type);
  
      if(addressKind==MARSHAL_FIRST_LEVEL_VALUE)
      {
--- 2953,2965 ----
      ILJitValue srcElemAddress;
      ILJitValue newElemAddress;
      ILJitValue counter;
!     ILJitValue arraySize;
! 
!     if(marshalType == IL_META_MARSHAL_CUSTOM)
      {
  	    fprintf(stderr, "Custom marshaling not supported in delegate by ref value\n");
  	    return;
      }
  
      if(addressKind==MARSHAL_FIRST_LEVEL_VALUE)
      {
